## mlton 20100608

=== Makefile ===
## Copyright (C) 2009 Matthew Fluet.
 # Copyright (C) 1999-2007 Henry Cejtin, Matthew Fluet, Suresh
 #    Jagannathan, and Stephen Weeks.
 # Copyright (C) 1997-2000 NEC Research Institute.
 #
 # MLton is released under a BSD-style license.
 # See the file MLton-LICENSE for details.
 ##

export TARGET := self
export TARGET_ARCH := $(shell bin/host-arch)
export TARGET_OS := $(shell bin/host-os)
ROOT := $(shell pwd)
BUILD := $(ROOT)/build
SRC := $(ROOT)
BIN := $(BUILD)/bin
LIB := $(BUILD)/lib
INC := $(LIB)/include
COMP := $(SRC)/mlton
RUN := $(SRC)/runtime
MLTON := $(BIN)/mlton
AOUT := mlton-compile
ifeq (mingw, $(TARGET_OS))
EXE := .exe
else
EXE :=
endif
MLBPATHMAP := $(LIB)/mlb-path-map
SPEC := package/rpm/mlton.spec
LEX := mllex
PROF := mlprof
YACC := mlyacc
NLFFIGEN := mlnlffigen
PATH := $(BIN):$(SRC)/bin:$(shell echo $$PATH)
CP := /bin/cp -fpR
GZIP := gzip --force --best
RANLIB := ranlib

# If we're compiling with another version of MLton, then we want to do
# another round of compilation so that we get a MLton built without
# stubs.
ifeq (other, $(shell if [ ! -x "$(BIN)/mlton" ]; then echo other; fi))
	BOOTSTRAP_OTHER:=true
else
	BOOTSTRAP_OTHER:=false
endif

ifeq ($(origin VERSION), undefined)
	VERSION := $(shell date +%Y%m%d)
endif
ifeq ($(origin RELEASE), undefined)
	RELEASE := 1
endif

.PHONY: all
all:
	$(MAKE) docs all-no-docs

.PHONY: all-no-docs
all-no-docs:
	$(MAKE) dirs runtime compiler basis-no-check script mlbpathmap constants libraries tools
# Remove $(AOUT) so that the $(MAKE) compiler below will remake MLton.
# We also want to re-run the just-built tools (mllex and mlyacc)
# because they may be better than those that were used for the first
# round of compilation.  So, we clean out the front end.
ifeq (true, $(BOOTSTRAP_OTHER))
	rm -f "$(COMP)/$(AOUT)$(EXE)"
	$(MAKE) -C "$(COMP)/front-end" clean
endif
	$(MAKE) compiler basis
	@echo 'Build of MLton succeeded.'

.PHONY: basis-no-check
basis-no-check:
	mkdir -p "$(LIB)/sml"
	rm -rf "$(LIB)/sml/basis"
	$(CP) "$(SRC)/basis-library/." "$(LIB)/sml/basis"
	find "$(LIB)/sml/basis" -type d -name .svn | xargs rm -rf
	find "$(LIB)/sml/basis" -type f -name .ignore | xargs rm -rf

.PHONY: basis
basis:
	$(MAKE) basis-no-check
	@echo 'Type checking basis.'
	"$(MLTON)" -disable-ann deadCode \
		-stop tc \
		'$$(SML_LIB)/basis/libs/all.mlb' \
		>/dev/null

.PHONY: bootstrap-nj
bootstrap-nj:
	$(MAKE) nj-mlton
	$(MAKE) all

.PHONY: clean
clean:
	bin/clean

.PHONY: clean-svn
clean-svn:
	find . -type d | grep .svn | xargs rm -rf

.PHONY: compiler
compiler:
	$(MAKE) -C "$(COMP)"
	$(CP) "$(COMP)/$(AOUT)$(EXE)" "$(LIB)/"

.PHONY: constants
constants:
	@echo 'Creating constants file.'
	"$(BIN)/mlton" -target "$(TARGET)" -build-constants true >tmp.c
	"$(BIN)/mlton" -target "$(TARGET)" -output tmp tmp.c
	./tmp >"$(LIB)/targets/$(TARGET)/constants"
	rm -f tmp tmp.exe tmp.c

.PHONY: debugged
debugged:
	$(MAKE) -C "$(COMP)" "AOUT=$(AOUT).debug" COMPILE_ARGS="-debug true -const 'Exn.keepHistory true' -profile-val true -const 'MLton.debug true' -drop-pass 'deepFlatten'"
	$(CP) "$(COMP)/$(AOUT).debug" "$(LIB)/"
	sed 's/mlton-compile/mlton-compile.debug/' < "$(MLTON)" > "$(MLTON).debug"
	chmod a+x "$(MLTON).debug"

.PHONY: dirs
dirs:
	mkdir -p "$(BIN)" "$(INC)"
	mkdir -p "$(LIB)/targets/$(TARGET)/include"
	mkdir -p "$(LIB)/targets/$(TARGET)/sml"

.PHONY: docs
docs: dirs
	$(MAKE) -C "$(LEX)" docs
	$(MAKE) -C "$(YACC)" docs
	if htmldoc --version >/dev/null 2>&1; then \
		bin/make-pdf-guide; \
	fi

LIBRARIES := ckit-lib cml mlnlffi-lib mlrisc-lib mlyacc-lib smlnj-lib

.PHONY: libraries-no-check
libraries-no-check:
	mkdir -p "$(LIB)/sml"
	cd "$(LIB)/sml" && rm -rf $(LIBRARIES)
	$(MAKE) -C "$(SRC)/lib/ckit-lib"
	$(MAKE) -C "$(SRC)/lib/mlnlffi-lib"
	$(MAKE) -C "$(SRC)/lib/mlrisc-lib"
	$(MAKE) -C "$(SRC)/lib/smlnj-lib"
	$(CP) "$(SRC)/lib/cml/." "$(LIB)/sml/cml"
	$(CP) "$(SRC)/lib/ckit-lib/ckit/." "$(LIB)/sml/ckit-lib"
	$(CP) "$(SRC)/lib/mlnlffi-lib/." "$(LIB)/sml/mlnlffi-lib"
	$(CP) "$(SRC)/lib/mlrisc-lib/MLRISC/." "$(LIB)/sml/mlrisc-lib"
	$(CP) "$(SRC)/lib/mlyacc-lib/." "$(LIB)/sml/mlyacc-lib"
	$(CP) "$(SRC)/lib/smlnj-lib/smlnj-lib/." "$(LIB)/sml/smlnj-lib"
	find "$(LIB)/sml" -type d -name .cm | xargs rm -rf
	find "$(LIB)/sml" -type d -name .svn | xargs rm -rf
	find "$(LIB)/sml" -type f -name .ignore | xargs rm -rf

.PHONY: libraries
libraries:
	$(MAKE) libraries-no-check
	for f in $(LIBRARIES); do				\
		echo "Type checking $$f library.";		\
		"$(MLTON)" -disable-ann deadCode		\
			-stop tc				\
			'$$(SML_LIB)/'"$$f/$$f.mlb"		\
			>/dev/null;				\
	done

.PHONY: mlbpathmap
mlbpathmap:
	touch "$(MLBPATHMAP)"
	( echo 'MLTON_ROOT $$(LIB_MLTON_DIR)/sml';	\
	  echo 'SML_LIB $$(LIB_MLTON_DIR)/sml'; )	\
		>>"$(MLBPATHMAP).tmp"
	mv "$(MLBPATHMAP).tmp" "$(MLBPATHMAP)"

.PHONY: polyml-mlton
polyml-mlton:
	$(MAKE) dirs runtime
	$(MAKE) -C "$(COMP)" polyml-mlton
	$(CP) "$(COMP)/mlton-polyml$(EXE)" "$(LIB)/"
	$(MAKE) script basis-no-check mlbpathmap constants libraries-no-check
	@echo 'Build of MLton succeeded.'

.PHONY: profiled
profiled:
	for t in alloc count time; do					\
		$(MAKE) -C "$(COMP)" "AOUT=$(AOUT).$$t"			\
			COMPILE_ARGS="-profile $$t";			\
		$(CP) "$(COMP)/$(AOUT).$$t" "$(LIB)/";			\
		sed "s/mlton-compile/mlton-compile.$$t/" 		\
			<"$(MLTON)" 					\
			>"$(MLTON).$$t";				\
		chmod a+x "$(MLTON).$$t";				\
	done

.PHONY: runtime
runtime:
	@echo 'Compiling MLton runtime system for $(TARGET).'
	$(MAKE) -C runtime
	$(CP) include/*.h "$(INC)/"
	$(CP) runtime/*.a "$(LIB)/targets/$(TARGET)/"
	$(CP) runtime/gen/sizes "$(LIB)/targets/$(TARGET)/"
	$(CP) runtime/gen/c-types.sml "$(LIB)/targets/$(TARGET)/sml/"
	echo "$(TARGET_OS)" > "$(LIB)/targets/$(TARGET)/os"
	echo "$(TARGET_ARCH)" > "$(LIB)/targets/$(TARGET)/arch"
	$(CP) runtime/gen/basis-ffi.sml \
		basis-library/primitive/basis-ffi.sml
ifeq ($(OMIT_BYTECODE), yes)
else
	$(CP) runtime/bytecode/opcodes "$(LIB)/"
endif
	$(CP) runtime/*.h "$(INC)/"
	mv "$(INC)/c-types.h" "$(LIB)/targets/$(TARGET)/include"
	for d in basis basis/Real basis/Word gc platform util; do	\
		mkdir -p "$(INC)/$$d";					\
		$(CP) runtime/$$d/*.h "$(INC)/$$d";			\
	done
ifeq ($(OMIT_BYTECODE), yes)
else
	$(CP) runtime/bytecode/interpret.h "$(INC)"
endif
	for x in "$(LIB)/targets/$(TARGET)"/*.a; do $(RANLIB) "$$x"; done

.PHONY: script
script:
	$(CP) bin/mlton-script "$(MLTON)"
	chmod a+x "$(MLTON)"
	$(CP) "$(SRC)/bin/platform" "$(LIB)"
	$(CP) "$(SRC)/bin/static-library" "$(LIB)"
ifeq (mingw, $(TARGET_OS))
	$(CP) "$(SRC)/bin/static-library.bat" "$(LIB)"
endif

.PHONY: smlnj-mlton
smlnj-mlton:
	$(MAKE) dirs runtime
	$(MAKE) -C "$(COMP)" smlnj-mlton
	smlnj_heap_suffix=`echo 'TextIO.output (TextIO.stdErr, SMLofNJ.SysInfo.getHeapSuffix ());' | sml 2>&1 1> /dev/null` && $(CP) "$(COMP)/mlton-smlnj.$$smlnj_heap_suffix" "$(LIB)/"
	$(MAKE) script basis-no-check mlbpathmap constants libraries-no-check
	@echo 'Build of MLton succeeded.'

.PHONY: smlnj-mlton-dual
smlnj-mlton-dual:
	$(MAKE) SMLNJ_CM_SERVERS_NUM=2 smlnj-mlton

.PHONY: smlnj-mlton-quad
smlnj-mlton-quad:
	$(MAKE) SMLNJ_CM_SERVERS_NUM=4 smlnj-mlton

.PHONY: traced
traced:
	$(MAKE) -C "$(COMP)" "AOUT=$(AOUT).trace" COMPILE_ARGS="-const 'Exn.keepHistory true' -profile-val true -const 'MLton.debug true' -drop-pass 'deepFlatten'"
	$(CP) "$(COMP)/$(AOUT).trace" "$(LIB)/"
	sed 's/mlton-compile/mlton-compile.trace/' < "$(MLTON)" > "$(MLTON).trace"
	chmod a+x "$(MLTON).trace"

.PHONY: tools
tools:
	$(MAKE) -C "$(LEX)"
	$(MAKE) -C "$(NLFFIGEN)"
	$(MAKE) -C "$(PROF)"
	$(MAKE) -C "$(YACC)"
	$(CP) "$(LEX)/$(LEX)$(EXE)"		\
		"$(NLFFIGEN)/$(NLFFIGEN)$(EXE)"	\
		"$(PROF)/$(PROF)$(EXE)"		\
		"$(YACC)/$(YACC)$(EXE)"		\
		"$(BIN)/"

.PHONY: version
version:
	@echo 'Instantiating version numbers.'
	for f in							\
		"$(SPEC)"						\
		package/freebsd/Makefile				\
		mlton/control/version_sml.src;				\
	do								\
		sed "s/\(.*\)MLTONVERSION\(.*\)/\1$(VERSION)\2/" <"$$f" >z && \
		mv z "$$f";						\
	done
	sed <"$(SPEC)" >z "/^Release:/s;.*;Release: $(RELEASE);"
	mv z "$(SPEC)"

.PHONY: check
check:
	./bin/regression

# The TBIN and TLIB are where the files are going to be after installing.
# The DESTDIR and is added onto them to indicate where the Makefile actually
# puts them.
DESTDIR := $(CURDIR)/install
PREFIX := /usr
ifeq ($(findstring $(TARGET_OS), darwin freebsd solaris), $(TARGET_OS))
PREFIX := /usr/local
endif
ifeq ($(TARGET_OS), mingw)
PREFIX := /mingw
endif
prefix := $(PREFIX)
MAN_PREFIX_EXTRA :=
TBIN := $(DESTDIR)$(prefix)/bin
ULIB := lib/mlton
TLIB := $(DESTDIR)$(prefix)/$(ULIB)
TMAN := $(DESTDIR)$(prefix)$(MAN_PREFIX_EXTRA)/man/man1
TDOC := $(DESTDIR)$(prefix)/share/doc/mlton
ifeq ($(findstring $(TARGET_OS), solaris mingw), $(TARGET_OS))
TDOC := $(DESTDIR)$(prefix)/doc/mlton
endif
TEXM := $(TDOC)/examples

GZIP_MAN := true
ifeq ($(TARGET_OS), solaris)
GZIP_MAN := false
endif

.PHONY: install
install: install-no-strip install-strip

.PHONY: install-no-strip
install-no-strip: install-docs install-no-docs move-docs 

MAN_PAGES :=  \
	mllex.1 \
	mlnlffigen.1 \
	mlprof.1 \
	mlton.1 \
	mlyacc.1

.PHONY: install-no-docs
install-no-docs:
	mkdir -p "$(TLIB)" "$(TBIN)" "$(TMAN)"
	$(CP) "$(LIB)/." "$(TLIB)/"
	sed "/^lib=/s;.*;lib='$(prefix)/$(ULIB)';"			\
		<"$(BIN)/mlton" >"$(TBIN)/mlton"
	chmod a+x "$(TBIN)/mlton"
	if [ -x "$(BIN)/mlton.trace" ]; then                            \
		sed "/^lib=/s;.*;lib='$(prefix)/$(ULIB)';"		\
			<"$(BIN)/mlton.trace" >"$(TBIN)/mlton.trace";   \
		chmod a+x "$(TBIN)/mlton.trace";                        \
	fi
	if [ -x "$(BIN)/mlton.debug" ]; then                            \
		sed "/^lib=/s;.*;lib='$(prefix)/$(ULIB)';"		\
			<"$(BIN)/mlton.debug" >"$(TBIN)/mlton.debug";   \
		chmod a+x "$(TBIN)/mlton.debug";                        \
	fi
	cd "$(BIN)" && $(CP) "$(LEX)$(EXE)" "$(NLFFIGEN)$(EXE)"		\
		 "$(PROF)$(EXE)" "$(YACC)$(EXE)" "$(TBIN)/"
	( cd "$(SRC)/man" && tar cf - $(MAN_PAGES)) | \
		( cd "$(TMAN)/" && tar xf - )
	if $(GZIP_MAN); then						\
		cd "$(TMAN)" && $(GZIP) $(MAN_PAGES);			\
	fi

.PHONY: install-strip
install-strip:
	case "$(TARGET_OS)" in						\
	aix|cygwin|darwin|solaris)					\
	;;								\
	*)								\
		for f in "$(TLIB)/$(AOUT)$(EXE)" "$(TBIN)/$(LEX)$(EXE)"	\
			"$(TBIN)/$(NLFFIGEN)$(EXE)" "$(TBIN)/$(PROF)$(EXE)" \
			"$(TBIN)/$(YACC)$(EXE)"; do			\
			strip --remove-section=.comment			\
				--remove-section=.note "$$f";		\
		done							\
	esac

.PHONY: install-docs
install-docs:
	mkdir -p "$(TDOC)"
	(								\
		cd "$(SRC)/doc" &&					\
		$(CP) changelog examples guide license README "$(TDOC)/" \
	)
	if [ -r "$(TDOC)/guide/mlton-guide.pdf" ]; then			\
		cp "$(TDOC)/guide/mlton-guide.pdf" "$(TDOC)/";		\
	fi
	(								\
		cd "$(SRC)/util" &&					\
		$(CP) cmcat cm2mlb "$(TDOC)/"				\
	)
	for f in callcc command-line hello-world same-fringe signals	\
			size taut thread1 thread2 thread-switch timeout \
		; do							\
		$(CP) "$(SRC)/regression/$$f.sml" "$(TEXM)/";		\
	done
	if test -r $(LEX)/$(LEX).pdf; then                              \
		$(CP) $(LEX)/$(LEX).pdf $(TDOC);                        \
	fi
	if test -r $(YACC)/$(YACC).pdf; then                            \
		$(CP) $(YACC)/$(YACC).pdf $(TDOC);                      \
	fi
	find "$(TDOC)/" -name .svn -type d | xargs rm -rf
	find "$(TDOC)/" -name .ignore -type f | xargs rm -rf
	find "$(TEXM)/" -name .svn -type d | xargs rm -rf
	find "$(TEXM)/" -name .ignore -type f | xargs rm -rf


.PHONY: move-docs
move-docs:	install-docs install-no-docs
	cd "$(TLIB)/sml"; for i in *; do test -d "$(TDOC)/$$i" || mkdir -p "$(TDOC)/$$i"; done
	cd "$(TLIB)/sml"; for i in */[Dd]oc; do mv "$$i" "$(TDOC)/$$i"; done
	cd "$(TLIB)/sml"; for i in */README*; do mv "$$i" "$(TDOC)/$$i"; done

.PHONY: release
release: version
	tar cvzf ../mlton-$(VERSION).tar.gz \
		--exclude .svn --exclude package \
		--transform "s@^@mlton-$(VERSION)/@" \
		*

BSDSRC := /tmp/mlton-$(VERSION)
.PHONY: freebsd
freebsd:
	$(MAKE) clean clean-svn version
	rm -rf "$(BSDSRC)"
	mkdir -p "$(BSDSRC)"

=== basis-library/Makefile ===
## Copyright (C) 2010 Matthew Fluet.
 # Copyright (C) 1999-2006, 2008 Henry Cejtin, Matthew Fluet, Suresh
 #    Jagannathan, and Stephen Weeks.
 # Copyright (C) 1997-2000 NEC Research Institute.
 #
 # MLton is released under a BSD-style license.
 # See the file MLton-LICENSE for details.
 ##

SRC = $(shell cd .. && pwd)
BUILD = $(SRC)/build
BIN = $(BUILD)/bin
MLTON = mlton
PATH = $(BIN):$(shell echo $$PATH)

all:

.PHONY: clean
clean:
	../bin/clean


OBJPTR_MAPS = objptr-rep32.map objptr-rep64.map 
HEADER_MAPS = header-word32.map header-word64.map
SEQINDEX_MAPS = seqindex-int32.map seqindex-int64.map 
DEFAULT_CHAR = char8
DEFAULT_INT = int32 int64 intinf
DEFAULT_REAL = real32 real64
DEFAULT_WORD = word32 word64

.PHONY: def-use
def-use:
	"$(MLTON)" -disable-ann deadCode -stop tc -show-types true \
		-prefer-abs-paths true -show-def-use basis-library.def-use \
		libs/all.mlb

.PHONY: type-check-def
type-check-def:
	"$(MLTON)" -disable-ann deadCode -stop tc -show-types true \
		libs/all.mlb

.PHONY: type-check-all
type-check-all:
	for objptrrep in $(OBJPTR_MAPS); do \
	for header in $(HEADER_MAPS); do \
	for seqindex in $(SEQINDEX_MAPS); do \
	for defchar in $(DEFAULT_CHAR); do \
	for defint in $(DEFAULT_INT); do \
	for defreal in $(DEFAULT_REAL); do \
	for defword in $(DEFAULT_WORD); do \
	echo "Type checking: $$objptrrep $$header $$seqindex $$defchar $$defint $$defreal $$defword"; \
	echo "$(MLTON)" -disable-ann deadCode -stop tc -show-types true \
		-mlb-path-map "maps/$$objptrrep" \
		-mlb-path-map "maps/$$header" \
		-mlb-path-map "maps/$$seqindex" \
		-default-type "$$defchar" \
		-default-type "$$defint" \
		-default-type "$$defreal" \
		-default-type "$$defword" \
		libs/all.mlb; \
	"$(MLTON)" -disable-ann deadCode -stop tc -show-types true \
		-mlb-path-map "maps/$$objptrrep" \
		-mlb-path-map "maps/$$header" \
		-mlb-path-map "maps/$$seqindex" \
		-default-type "$$defchar" \
		-default-type "$$defint" \
		-default-type "$$defreal" \
		-default-type "$$defword" \
		libs/all.mlb; \
	done; done; done; done; done; done; done;

=== man/Makefile ===
## Copyright (C) 1999-2005 Henry Cejtin, Matthew Fluet, Suresh
 #    Jagannathan, and Stephen Weeks.
 # Copyright (C) 1997-2000 NEC Research Institute.
 #
 # MLton is released under a BSD-style license.
 # See the file MLton-LICENSE for details.
 ##

all:

.PHONY: ps
ps: mllex.ps mlprof.ps mlton.ps

%.pdf: %.ps
	ps2pdf $<

%.ps: %.1
	man -t ./$< >$@

.PHONY: clean
clean:
	../bin/clean

=== mllex/Makefile ===
## Copyright (C) 2009 Matthew Fluet.
 # Copyright (C) 1999-2006 Henry Cejtin, Matthew Fluet, Suresh
 #    Jagannathan, and Stephen Weeks.
 # Copyright (C) 1997-2000 NEC Research Institute.
 #
 # MLton is released under a BSD-style license.
 # See the file MLton-LICENSE for details.
 ##

SRC := $(shell cd .. && pwd)
BUILD := $(SRC)/build
BIN := $(BUILD)/bin
LIB := $(BUILD)/lib
MLTON := mlton
TARGET := self
FLAGS := -target $(TARGET)
NAME := mllex
PATH := $(BIN):$(shell echo $$PATH)

all:	$(NAME)

$(NAME): $(NAME).mlb $(shell PATH="$(BIN):$$PATH" && "$(MLTON)" -stop f $(NAME).mlb)
	@echo 'Compiling $(NAME)'
	"$(MLTON)" $(FLAGS) $(NAME).mlb

html/index.html: $(TEX_FILES)
	mkdir -p html
	hevea -fix -o html/mllex.html -exec xxdate.exe macros.hva lexgen.tex
	cd html && hacha mllex.html && rm -f mllex.html

lexgen.dvi: lexgen.tex
	latex lexgen.tex
	latex lexgen.tex

mllex.pdf: lexgen.tex
	latex lexgen.tex
	pdflatex lexgen.tex
	mv lexgen.pdf mllex.pdf

mllex.ps: lexgen.dvi
	dvips -o mllex.ps lexgen.dvi

.PHONY: clean
clean:
	../bin/clean

.PHONY: docs
docs: mllex.pdf

.PHONY: test
test: $(NAME)
	cp -p ../mlton/front-end/ml.lex . &&			\
	$(NAME) ml.lex &&					\
	diff ml.lex.sml ../mlton/front-end/ml.lex.sml

=== mlprof/Makefile ===
## Copyright (C) 2009 Matthew Fluet.
 # Copyright (C) 1999-2006 Henry Cejtin, Matthew Fluet, Suresh
 #    Jagannathan, and Stephen Weeks.
 # Copyright (C) 1997-2000 NEC Research Institute.
 #
 # MLton is released under a BSD-style license.
 # See the file MLton-LICENSE for details.
 ##

SRC := $(shell cd .. && pwd)
BUILD := $(SRC)/build
BIN := $(BUILD)/bin
LIB := $(BUILD)/lib
MLTON := mlton
TARGET := self
FLAGS := -target $(TARGET) -default-ann 'sequenceNonUnit warn' -default-ann 'warnUnused true'
NAME := mlprof
PATH := $(BIN):$(shell echo $$PATH)

all:	$(NAME)

$(NAME): $(NAME).mlb $(shell PATH="$(BIN):$$PATH" && "$(MLTON)" -stop f $(NAME).mlb)
	@echo 'Compiling $(NAME)'
	$(MLTON) $(FLAGS) $(NAME).mlb

.PHONY: clean
clean:
	../bin/clean

.PHONY: test
test: $(NAME)
	./mlprof z mlmon.out

=== mlton/Makefile ===
## Copyright (C) 2010 Matthew Fluet.
 # Copyright (C) 1999-2009 Henry Cejtin, Matthew Fluet, Suresh
 #    Jagannathan, and Stephen Weeks.
 # Copyright (C) 1997-2000 NEC Research Institute.
 #
 # MLton is released under a BSD-style license.
 # See the file MLton-LICENSE for details.
 ##

SRC := $(shell cd .. && pwd)
BUILD := $(SRC)/build
BIN := $(BUILD)/bin
HOST_ARCH := $(shell "$(SRC)/bin/host-arch")
HOST_OS := $(shell "$(SRC)/bin/host-os")
LIB := $(BUILD)/lib
TARGET := self
AOUT := mlton-compile
PATH := $(BIN):$(shell echo $$PATH)

FLAGS := @MLton ram-slop 0.7 gc-summary $(RUNTIME_ARGS) --

ifeq (self, $(shell if [ -x "$(BIN)/mlton" ]; then echo self; fi))
  # We're compiling MLton with itself, so don't use any stubs.
  FILE := mlton.mlb
  FLAGS += -default-ann 'sequenceNonUnit warn'
  FLAGS += -default-ann 'warnUnused true'
  # FLAGS += -type-check true
else
# We're compiling MLton with an older version of itself. 
# Use "-align 8" for amd64 to avoid GMP/mul_2exp segfault with a
# mis-aligned limb when compiling with <= 20070826.
ifeq (amd64,$(findstring $(HOST_ARCH), amd64))
  FLAGS += -align 8
endif
ifneq (,$(findstring $(HOST_OS), cygwin mingw))
  # The stubs don't work on Cygwin or MinGW, since they define spawn
  # in terms of fork, and fork doesn't work on Cygwin or MinGW.  So,
  # make without the stubs.
  FILE := mlton.mlb
else
  # We're compiling MLton with an older version of itself, so use the stubs for
  # the MLton structure.
  FILE := mlton-stubs.mlb
endif
endif

FLAGS += -target $(TARGET)
FLAGS += -verbose 2 -output "$(AOUT)"
FLAGS += $(COMPILE_ARGS)

FRONT_END_SOURCES :=		\
	front-end/ml.lex.sml	\
	front-end/ml.grm.sig	\
	front-end/ml.grm.sml	\
	front-end/mlb.lex.sml	\
	front-end/mlb.grm.sig	\
	front-end/mlb.grm.sml

SOURCES :=			\
	$(FILE)			\
	upgrade-basis.sml	\
	$(FRONT_END_SOURCES)	\
	$(filter-out control/version.sml,$(shell if [ -r $(FILE) ]; then mlton -stop f $(FILE) | grep -v " "; fi))

.PHONY: all
all: $(AOUT)

control/version.sml: control/version_sml.src
	cat control/version_sml.src |						\
		sed "s/MLTONVERSION/$${VERSION:-r`svnversion||echo unknown`}/" |\
		sed "s/\(.*\)MLTONBUILDDATE\(.*\)/\1`LANG=C date`\2/" |		\
		sed "s/\(.*\)MLTONBUILDNODE\(.*\)/\1`uname -n`\2/" >		\
		control/version.sml

front-end/%.lex.sml: front-end/%.lex
	$(MAKE) -C front-end $(@F)
front-end/%.grm.sig front-end/%.grm.sml: front-end/%.grm
	$(MAKE) -C front-end $(<F).sig $(<F).sml

# Pass $(PATH) to upgrade-basis because it is run via
# #!/usr/bin/env bash, which resets the path.
upgrade-basis.sml:
	"$(SRC)/bin/upgrade-basis" '$(PATH)' "$(HOST_ARCH)" "$(HOST_OS)" >upgrade-basis.sml

mlton-stubs.mlb: $(shell mlton -stop f ../lib/stubs/mlton-stubs/sources.mlb) $(shell mlton -stop f mlton.mlb)
	(									\
		echo '$$(SML_LIB)/basis/unsafe.mlb';				\
		echo '$$(SML_LIB)/basis/sml-nj.mlb';				\
		echo '$$(SML_LIB)/basis/mlton.mlb';				\
		echo '$$(SML_LIB)/basis/basis.mlb';				\
		echo 'upgrade-basis.sml';					\
		mlton -stop f mlton.mlb | grep -v 'mlb$$' | grep 'mlyacc';	\
		mlton -stop f ../lib/stubs/mlton-stubs/sources.mlb |		\
			grep -v 'mlb$$' | 					\
			grep 'mlton-stubs';					\
		mlton -stop f mlton.mlb |					\
			grep -v 'mlb$$' |					\
			grep -v 'sml/basis' | 					\
			grep -v 'targets' | 					\
			grep -v 'mlyacc';					\
	) > mlton-stubs.mlb

$(AOUT): $(SOURCES)
	rm -f upgrade-basis.sml
	$(MAKE) upgrade-basis.sml
	rm -f control/version.sml
	$(MAKE) control/version.sml
	@echo 'Compiling mlton (takes a while)'
	mlton $(FLAGS) $(FILE)

.PHONY: def-use
def-use: mlton.def-use

mlton.def-use: $(SOURCES)
	mlton $(FLAGS) -stop tc -prefer-abs-paths true -show-def-use mlton.def-use $(FILE)

.PHONY: clean
clean:
	../bin/clean

#
# The following rebuilds the heap file for the SML/NJ compiled version
# of MLton.
#
SMLNJ := sml
SMLNJ_CM_SERVERS_NUM := 0

.PHONY: smlnj-mlton
smlnj-mlton: $(FRONT_END_SOURCES)
	rm -f control/version.sml
	$(MAKE) control/version.sml
	(									\
		echo 'SMLofNJ.Internals.GC.messages false;';			\
		echo '#set CM.Control.verbose false;';				\
		echo '#set CM.Control.warn_obsolete false;';			\
		echo 'Control.polyEqWarn := false;';				\
		echo 'local';							\
		echo 'fun loop 0 = () | loop n = (CM.Server.start {cmd = (CommandLine.name (), ["@CMslave"]), name = "server" ^ (Int.toString n), pathtrans = NONE, pref = 0}; loop (n - 1));'; \
		echo 'in';							\
		echo 'val _ = loop $(SMLNJ_CM_SERVERS_NUM);';			\
		echo 'end;';							\
		echo 'if (CM.make "mlton-smlnj.cm") handle _ => false';		\
		echo '   then ()';						\
		echo '   else OS.Process.exit OS.Process.failure;'; 		\
		echo 'SMLofNJ.exportFn("mlton-smlnj",Main.main);'		\
	) | "$(SMLNJ)"

#
# The following rebuilds the executable file for the Poly/ML compiled
# version of MLton.
#
POLYML	:= poly

.PHONY: polyml-mlton
polyml-mlton: mlton-polyml.use $(FRONT_END_SOURCES)
	rm -f control/version.sml
	$(MAKE) control/version.sml
	(									\
		echo 'use "mlton-polyml.use";';					\
		echo 'PolyML.export("mlton-polyml", Main.mainWrapped);';	\
	) | "$(POLYML)"
	$(CC) -o mlton-polyml mlton-polyml.o -lpolymain -lpolyml
	rm -f mlton-polyml.o

mlton-polyml.use: ../lib/stubs/basis-stubs-for-polyml/sources.use ../lib/stubs/mlton-stubs-for-polyml/sources.use $(shell mlton -stop f ../lib/stubs/mlton-stubs/sources.mlb) $(filter-out control/version.sml,$(shell mlton -stop f mlton.mlb))
	(									\
		cat ../lib/stubs/basis-stubs-for-polyml/sources.use |		\
			sed 's|use "\(.*\)";|../lib/stubs/basis-stubs-for-polyml/\1|'; \
		mlton -stop f mlton.mlb | grep -v 'mlb$$' | grep 'mlyacc';	\
		cat ../lib/stubs/mlton-stubs-for-polyml/sources.use |		\
			sed 's|use "\(.*\)";|../lib/stubs/mlton-stubs-for-polyml/\1|'; \
		mlton -stop f ../lib/stubs/mlton-stubs/sources.mlb |		\
			grep -v 'mlb$$' | 					\
			grep 'mlton-stubs';					\
		mlton -stop f mlton.mlb |					\
			grep -v 'mlb$$' |					\
			grep -v 'sml/basis' | 					\
			grep -v 'targets' | 					\
			grep -v 'mlton-stubs' |					\
			grep -v 'mlyacc' |					\
			grep -v 'call-main.sml';				\
	) | sed 's|\(.*\)|use "\1";|' > mlton-polyml.use

=== mlyacc/Makefile ===
## Copyright (C) 2009 Matthew Fluet.
 # Copyright (C) 1999-2006 Henry Cejtin, Matthew Fluet, Suresh
 #    Jagannathan, and Stephen Weeks.
 # Copyright (C) 1997-2000 NEC Research Institute.
 #
 # MLton is released under a BSD-style license.
 # See the file MLton-LICENSE for details.
 ##

SRC := $(shell cd .. && pwd)
BUILD := $(SRC)/build
BIN := $(BUILD)/bin
LIB := $(BUILD)/lib
MLTON := mlton
TARGET := self
FLAGS := -target $(TARGET)
NAME := mlyacc
PATH := $(BIN):$(shell echo $$PATH)

ifeq (mllex, $(shell if mllex >/dev/null 2>&1 || [ $$? != 127 ] ; then echo mllex; fi))
MLLEX := mllex
else
ifeq (ml-lex, $(shell if ml-lex >/dev/null 2>&1 || [ $$? != 127 ] ; then echo ml-lex; fi))
MLLEX := ml-lex
else
MLLEX := no-mllex
endif
endif

ifeq (mlyacc, $(shell if mlyacc >/dev/null 2>&1 || [ $$? != 127 ] ; then echo mlyacc; fi))
MLYACC := mlyacc
else
ifeq (ml-yacc, $(shell if ml-lex >/dev/null 2>&1 || [ $$? != 127 ] ; then echo ml-yacc; fi))
MLYACC := ml-yacc
else
MLYACC := no-mlyacc
endif
endif

all:	$(NAME)

$(NAME): $(NAME).mlb $(shell PATH="$(BIN):$$PATH" && "$(MLTON)" -stop f $(NAME).mlb)
	@echo 'Compiling $(NAME)'
	"$(MLTON)" $(FLAGS) $(NAME).mlb

src/yacc.lex.sml: src/yacc.lex
	rm -f src/yacc.lex.sml && \
		$(MLLEX) src/yacc.lex && \
		chmod -w src/yacc.lex.sml

src/%.grm.sig src/%.grm.sml: src/%.grm
	rm -f $<.* 
	$(MLYACC) $<
	chmod -w $<.*

doc/mlyacc.ps:
	$(MAKE) -C doc mlyacc.ps

doc/mlyacc.pdf:
	$(MAKE) -C doc mlyacc.pdf

mlyacc.ps: doc/mlyacc.ps
	cp doc/mlyacc.ps .

mlyacc.pdf: doc/mlyacc.pdf
	cp doc/mlyacc.pdf .

.PHONY: clean
clean:
	../bin/clean

.PHONY: docs
docs: mlyacc.pdf

.PHONY: test
test: $(NAME)
	cp -p ../mlton/front-end/ml.grm . &&			\
	$(NAME) ml.grm &&					\
	diff ml.grm.sig ../mlton/front-end/ml.grm.sig &&	\
	diff ml.grm.sml ../mlton/front-end/ml.grm.sml

=== runtime/Makefile ===
## Copyright (C) 2010 Matthew Fluet.
 # Copyright (C) 1999-2009 Henry Cejtin, Matthew Fluet, Suresh
 #    Jagannathan, and Stephen Weeks.
 # Copyright (C) 1997-2000 NEC Research Institute.
 #
 # MLton is released under a BSD-style license.
 # See the file MLton-LICENSE for details.
 ##

PATH := ../bin:$(shell echo $$PATH)

TARGET := self

ifeq ($(TARGET), self)
CC := gcc -std=gnu99
AR := ar rc
RANLIB := ranlib
else
CC := $(TARGET)-gcc -std=gnu99
AR := $(TARGET)-ar rc
RANLIB := $(TARGET)-ranlib
endif

TARGET_ARCH := $(shell ../bin/host-arch)
TARGET_OS := $(shell ../bin/host-os)
GCC_MAJOR_VERSION :=						\
	$(shell $(CC) -v 2>&1 | grep 'gcc version' | 		\
		sed 's/.*gcc version \([0-9][0-9]*\)\.\([0-9][0-9]*\).*/\1/')
GCC_MINOR_VERSION :=						\
	$(shell $(CC) -v 2>&1 | grep 'gcc version' | 		\
		sed 's/.*gcc version \([0-9][0-9]*\)\.\([0-9][0-9]*\).*/\2/')
GCC_VERSION := $(GCC_MAJOR_VERSION).$(GCC_MINOR_VERSION)

FLAGS := -fno-common
EXE :=
OPTFLAGS := -O2 -fomit-frame-pointer
DEBUGFLAGS := -O1 -fno-inline -fkeep-inline-functions -g2
PICFLAGS := -DPIC
GCOPTFLAGS :=
GCDEBUGFLAGS :=
GCPICFLAGS :=
WARNFLAGS :=
OPTWARNFLAGS :=
DEBUGWARNFLAGS :=
PICWARNFLAGS :=

# Win32&64 don't use PIC code, all other platforms do
ifeq ($(findstring $(TARGET_OS), mingw cygwin),)
PICFLAGS += -fPIC
endif

# Make mlton library symbols private (win32&64 use another technique)
ifeq ($(findstring $(GCC_MAJOR_VERSION), 4),$(GCC_MAJOR_VERSION))
ifeq ($(findstring $(TARGET_OS), mingw cygwin),)
FLAGS += -fvisibility=hidden
endif
endif

ifeq ($(TARGET_ARCH), alpha)
FLAGS += -mieee -mbwx -mtune=ev6 -mfp-rounding-mode=d
endif

ifeq ($(TARGET_ARCH), amd64)
FLAGS += -m64
DEBUGFLAGS += -gstabs+
endif

ifeq ($(findstring $(TARGET_ARCH), hppa ia64 powerpc sparc),$(TARGET_ARCH))
ifeq (4.2, $(firstword $(sort $(GCC_VERSION) 4.2)))
# GMP headers contain C99 inline functions which generate warnings
# with a suggestion to use this flag to disable the warnings.
FLAGS += -fgnu89-inline
endif
endif

ifeq ($(TARGET_ARCH), ia64)
FLAGS += -mtune=itanium2
ifeq ($(TARGET_OS), hpux)
FLAGS += -mlp64
endif
endif

ifeq ($(TARGET_OS)-$(TARGET_ARCH), aix-powerpc64)
FLAGS += -maix64
AR := ar -X 64 rc
endif

ifeq ($(TARGET_ARCH), sparc)
FLAGS += -m32 -mcpu=v8 -Wa,-xarch=v8plusa
endif

ifeq ($(TARGET_ARCH), x86)
FLAGS += -m32
ifeq (3, $(firstword $(sort $(GCC_MAJOR_VERSION) 3)))
OPTFLAGS += -falign-loops=2 -falign-jumps=2 -falign-functions=5
else
OPTFLAGS += -malign-loops=2 -malign-jumps=2 -malign-functions=5
endif
DEBUGFLAGS += -gstabs+
endif

ifeq ($(TARGET_OS), cygwin)
EXE := .exe
endif

ifeq ($(TARGET_OS), darwin)
FLAGS += -I/usr/local/include -I/sw/include -I/opt/local/include
endif

ifeq ($(TARGET_OS), freebsd)
FLAGS += -I/usr/local/include
endif

ifeq ($(TARGET_OS), mingw)
EXE := .exe
endif

ifeq ($(TARGET_OS), netbsd)
FLAGS += -I/usr/pkg/include
endif

ifeq ($(TARGET_OS), openbsd)
FLAGS += -I/usr/local/include
endif

ifeq ($(TARGET_OS), solaris)
FLAGS += -funroll-all-loops
endif

# These flags can be overridden by the user 
CPPFLAGS :=
CFLAGS := 

INCFLAGS := -I. -Iplatform
OPTCFLAGS := $(CFLAGS) $(INCFLAGS) $(CPPFLAGS) $(FLAGS) $(OPTFLAGS)
DEBUGCFLAGS := $(CFLAGS) $(INCFLAGS) $(CPPFLAGS) $(FLAGS) -DASSERT=1 $(DEBUGFLAGS)
PICCFLAGS := $(CFLAGS) $(INCFLAGS) $(CPPFLAGS) $(FLAGS) $(OPTFLAGS) $(PICFLAGS)
GCOPTCFLAGS = $(GCOPTFLAGS)
GCDEBUGCFLAGS = $(GCDEBUGFLAGS)
GCPICCFLAGS = $(GCOPTFLAGS) $(GCPICFLAGS)
WARNCFLAGS :=
WARNCFLAGS += -pedantic -Wall
ifeq ($(findstring $(GCC_MAJOR_VERSION), 3),$(GCC_MAJOR_VERSION))
WARNCFLAGS += -W
endif
ifeq ($(findstring $(GCC_MAJOR_VERSION), 4),$(GCC_MAJOR_VERSION))
WARNCFLAGS += -Wextra
endif
WARNCFLAGS += -Wformat=2
ifeq ($(findstring $(GCC_MAJOR_VERSION), 4),$(GCC_MAJOR_VERSION))
WARNCFLAGS += -Wswitch-default -Wswitch-enum
endif
WARNCFLAGS += -Wuninitialized
ifeq ($(findstring $(GCC_MAJOR_VERSION), 4),$(GCC_MAJOR_VERSION))
WARNCFLAGS += -Winit-self
endif
ifeq ($(findstring $(GCC_MAJOR_VERSION), 4),$(GCC_MAJOR_VERSION))
WARNCFLAGS += -Wstrict-aliasing=2
endif
WARNCFLAGS += -Wfloat-equal
WARNCFLAGS += -Wundef
WARNCFLAGS += -Wshadow
WARNCFLAGS += -Wpointer-arith
WARNCFLAGS += -Wbad-function-cast -Wcast-qual
WARNCFLAGS += -Wwrite-strings
# WARNCFLAGS += -Wconversion
WARNCFLAGS += -Waggregate-return
WARNCFLAGS += -Wstrict-prototypes
ifeq ($(findstring $(GCC_MAJOR_VERSION), 4),$(GCC_MAJOR_VERSION))
WARNCFLAGS += -Wold-style-definition
endif
WARNCFLAGS += -Wmissing-prototypes -Wmissing-declarations
ifeq ($(findstring $(GCC_MAJOR_VERSION), 4),$(GCC_MAJOR_VERSION))
WARNCFLAGS += -Wmissing-field-initializers
endif
WARNCFLAGS += -Wmissing-noreturn
WARNCFLAGS += -Wmissing-format-attribute
# WARNCFLAGS += -Wpacked
# WARNCFLAGS += -Wpadded
WARNCFLAGS += -Wredundant-decls
WARNCFLAGS += -Wnested-externs
WARNCFLAGS += -Wlong-long
# WARNCFLAGS += -Wunreachable-code
WARNCFLAGS += $(WARNFLAGS)

# GCC doesn't recognize the %I64 format specifier which means %ll on windows
ifeq ($(TARGET_OS), mingw)
WARNCFLAGS += -Wno-format -Wno-missing-format-attribute
endif

OPTWARNCFLAGS := $(WARNCFLAGS) -Wdisabled-optimization $(OPTWARNFLAGS)
DEBUGWARNCFLAGS := $(WARNCFLAGS) $(DEBUGWARNFLAGS)
PICWARNCFLAGS := $(WARNCFLAGS)  -Wdisabled-optimization $(OPTWARNFLAGS)


GDTOACFILES :=									\
	dmisc.c    g__fmt.c   misc.c     strtoIdd.c  strtopdd.c  strtorf.c	\
	dtoa.c     gmisc.c    smisc.c    strtoIf.c   strtopf.c   strtorQ.c	\
	g_ddfmt.c  g_Qfmt.c   strtod.c   strtoIg.c   strtopQ.c   strtorx.c	\
	g_dfmt.c   g_xfmt.c   strtodg.c  strtoIQ.c   strtopx.c   strtorxL.c	\
	gdtoa.c    g_xLfmt.c  strtodI.c  strtoIx.c   strtopxL.c  sum.c		\
	gethex.c   hd_init.c  strtof.c   strtoIxL.c  strtord.c   ulp.c		\
	g_ffmt.c   hexnan.c   strtoId.c  strtopd.c   strtordd.c
GDTOACFILES := $(patsubst %,gdtoa/%,$(GDTOACFILES))

UTILHFILES :=							\
	util.h							\
	$(shell find util -type f | grep '\.h$$')
UTILCFILES :=							\
	$(shell find util -type f | grep '\.c$$')

PLATFORMHFILES :=						\
	platform.h						\
	$(shell find platform -type f | grep '\.h$$')
PLATFORMCFILES :=						\
	$(shell find platform -type f | grep '\.c$$')

GCHFILES :=							\
	gc.h							\
	$(shell find gc -type f | grep '\.h$$')
GCCFILES :=							\
	$(shell find gc -type f | grep '\.c$$')

BYTECODEHFILES :=						\
	$(shell find bytecode -type f | grep '\.h$$')

BASISHFILES :=							\
	ml-types.h						\
	c-types.h						\
	basis-ffi.h						\
	$(shell find basis -type f | grep '\.h$$')
BASISCFILES :=							\
	$(shell find basis -type f | grep '\.c$$')

HFILES :=							\
	cenv.h							\
	$(UTILHFILES)						\
	$(PLATFORMHFILES)					\
	$(GCHFILES)						\
	$(BASISHFILES)


GDTOA_OBJS       := $(patsubst %.c,%.o,$(GDTOACFILES))
GDTOA_DEBUG_OBJS := $(patsubst %.c,%-gdb.o,$(GDTOACFILES))
GDTOA_PIC_OBJS   := $(patsubst %.c,%-pic.o,$(GDTOACFILES))


OBJS := 							\
	util.o							\
	platform.o						\
	platform/$(TARGET_OS).o					\
	gc.o

OMIT_BYTECODE := no
ifeq ($(OMIT_BYTECODE), yes)
else
  OBJS += bytecode/interpret.o
endif

ifeq ($(COMPILE_FAST), yes)
  OBJS += basis.o
else
  OBJS += 							\
	$(foreach f, $(basename $(BASISCFILES)), $(f).o)
endif

DEBUG_OBJS := $(patsubst %.o,%-gdb.o,$(OBJS))
PIC_OBJS   := $(patsubst %.o,%-pic.o,$(OBJS))


ALL := libgdtoa.a libgdtoa-gdb.a libgdtoa-pic.a \
       libmlton.a libmlton-gdb.a libmlton-pic.a
ALL += gen/c-types.sml gen/basis-ffi.sml gen/sizes
ifeq ($(OMIT_BYTECODE), yes)
else
  ALL += bytecode/opcodes
endif

all: $(ALL)


gdtoa/arithchk.c: gdtoa.tgz gdtoa-patch gdtoa-patch.internal gdtoa-patch.mlton
	gzip -dc gdtoa.tgz | tar xf -
	patch -s -p0 <gdtoa-patch
	patch -s -p0 <gdtoa-patch.internal
	patch -s -p0 <gdtoa-patch.mlton

$(GDTOACFILES): gdtoa/arithchk.c
	@touch $@

gdtoa/arithchk.out: gdtoa/arithchk.c
	cd gdtoa && $(CC) $(OPTCFLAGS) $(OPTWARNCFLAGS) -w -O1 -o arithchk.out arithchk.c

gdtoa/arith.h: gdtoa/arithchk.out
	cd gdtoa && ./arithchk.out >arith.h

gdtoa/%-pic.o: gdtoa/%.c gdtoa/arith.h
	$(CC) $(PICCFLAGS) $(PICWARNCFLAGS) -w -DINFNAN_CHECK -c -o $@ $<
gdtoa/%-gdb.o: gdtoa/%.c gdtoa/arith.h
	$(CC) $(DEBUGCFLAGS) $(DEBUGWARNCFLAGS) -w -DINFNAN_CHECK -c -o $@ $<
gdtoa/%.o:     gdtoa/%.c gdtoa/arith.h
	$(CC) $(OPTCFLAGS) $(OPTWARNCFLAGS) -w -DINFNAN_CHECK -c -o $@ $<

libgdtoa.a:     $(GDTOA_OBJS)
libgdtoa-gdb.a: $(GDTOA_DEBUG_OBJS)
libgdtoa-pic.a: $(GDTOA_PIC_OBJS)


util-pic.o: util.c $(UTILCFILES) cenv.h $(UTILHFILES)
	$(CC) $(PICCFLAGS) $(PICWARNCFLAGS) -c -o $@ $<
util-gdb.o: util.c $(UTILCFILES) cenv.h $(UTILHFILES)
	$(CC) $(DEBUGCFLAGS) $(DEBUGWARNCFLAGS) -c -o $@ $<
util.o:     util.c $(UTILCFILES) cenv.h $(UTILHFILES)
	$(CC) $(OPTCFLAGS) $(OPTWARNCFLAGS) -c -o $@ $<

c-types.h: gen/c-types.h
	cp $< $@
ml-types.h: gen/ml-types.h
	cp $< $@
gen/c-types.h gen/c-types.sml gen/ml-types.h: gen/gen-types.stamp
	@touch $@
gen/gen-types.stamp: gen/gen-types.c util.h util.o
	$(CC) $(OPTCFLAGS) $(WARNCFLAGS) -o gen/gen-types gen/gen-types.c util.o
	rm -f gen/c-types.h gen/c-types.sml gen/ml-types.h gen/gen-types.stamp
	cd gen && ./gen-types
	rm -f gen/gen-types$(EXE) gen/gen-types
	touch $@

basis-ffi.h: gen/basis-ffi.h
	cp $< $@
gen/basis-ffi.h gen/basis-ffi.sml: gen/gen-basis-ffi.stamp
	@touch $@
gen/gen-basis-ffi.stamp: gen/gen-basis-ffi.sml gen/basis-ffi.def
	mlton -output gen/gen-basis-ffi gen/gen-basis-ffi.sml
	rm -f gen/basis-ffi.h gen/basis-ffi.sml gen/gen-basis-ffi.stamp
	cd gen && ./gen-basis-ffi
	rm -f gen/gen-basis-ffi
	touch $@

gen/sizes: gen/gen-sizes.stamp
	@touch $@
gen/gen-sizes.stamp: gen/gen-sizes.c libmlton.a $(HFILES)
	$(CC) $(OPTCFLAGS) $(WARNCFLAGS) -I. -o gen/gen-sizes gen/gen-sizes.c -L. -lmlton
	rm -f gen/sizes
	cd gen && ./gen-sizes
	rm -f gen/gen-sizes$(EXE) gen/gen-sizes
	touch $@

platform/$(TARGET_OS)-pic.o: $(PLATFORMCFILES)
platform/$(TARGET_OS)-gdb.o: $(PLATFORMCFILES)
platform/$(TARGET_OS).o: $(PLATFORMCFILES)

gc-pic.o: gc.c $(GCCFILES) $(HFILES)
	$(CC) $(PICCFLAGS) $(GCPICCFLAGS) $(PICWARNCFLAGS) -c -o $@ $<
gc-gdb.o: gc.c $(GCCFILES) $(HFILES)
	$(CC) $(DEBUGCFLAGS) $(GCDEBUGCFLAGS) $(DEBUGWARNCFLAGS) -c -o $@ $<
gc.o: gc.c $(GCCFILES) $(HFILES)
	$(CC) $(OPTCFLAGS) $(GCOPTCFLAGS) $(OPTWARNCFLAGS) -c -o $@ $<

## Needs -Wno-float-equal for Real<N>_equal, included via "c-chunk.h".
bytecode/interpret-pic.o: bytecode/interpret.c $(HFILES) $(BYTECODEHFILES)
	$(CC) -I../include $(PICCFLAGS) $(GCPICCFLAGS) $(PICWARNCFLAGS) -Wno-float-equal -c -o $@ $<
bytecode/interpret-gdb.o: bytecode/interpret.c $(HFILES) $(BYTECODEHFILES)
	$(CC) -I../include $(DEBUGCFLAGS) $(GCDEBUGCFLAGS) $(DEBUGWARNCFLAGS) -Wno-float-equal -c -o $@ $<
bytecode/interpret.o: bytecode/interpret.c $(HFILES) $(BYTECODEHFILES)
	$(CC) -I../include $(OPTCFLAGS) $(GCOPTCFLAGS) $(OPTWARNCFLAGS) -Wno-float-equal -c -o $@ $<

bytecode/opcodes: bytecode/print-opcodes
	@touch $@
bytecode/print-opcodes: bytecode/print-opcodes.c bytecode/opcode.h $(HFILES)
	$(CC) $(OPTCFLAGS) $(WARNCFLAGS) -o bytecode/print-opcodes bytecode/print-opcodes.c
	rm -f bytecode/opcodes
	cd bytecode && ./print-opcodes > opcodes

basis.c: $(BASISCFILES)
	rm -f basis.c
	cat $(BASISCFILES) >> basis.c

## Needs -Wno-float-equal for Real<N>_equal;
## needs -Wno-format-nonliteral for Date_strfTime;
## needs -Wno-redundant-decls for 'extern struct GC_state gcState'.
basis-pic.o: basis.c $(BASISCFILES) $(HFILES)
	$(CC) -Ibasis -Ibasis/Word -Ibasis/Real $(PICCFLAGS) $(PICWARNCFLAGS) -Wno-float-equal -Wno-format-nonliteral -Wno-redundant-decls -c -o $@ $<
basis-gdb.o: basis.c $(BASISCFILES) $(HFILES)
	$(CC) -Ibasis -Ibasis/Word -Ibasis/Real $(DEBUGCFLAGS) $(DEBUGWARNCFLAGS) -Wno-float-equal -Wno-format-nonliteral -Wno-redundant-decls -c -o $@ $<
basis.o: basis.c $(BASISCFILES) $(HFILES)
	$(CC) -Ibasis -Ibasis/Word -Ibasis/Real $(OPTCFLAGS) $(OPTWARNCFLAGS) -Wno-float-equal -Wno-format-nonliteral -Wno-redundant-decls -c -o $@ $<
## Needs -Wno-float-equal for Real<N>_equal.
basis/Real/Real-pic.o: basis/Real/Real.c $(HFILES)
	$(CC) $(PICCFLAGS) $(PICWARNCFLAGS) -Wno-float-equal -c -o $@ $<
basis/Real/Real-gdb.o: basis/Real/Real.c $(HFILES)

=== Doc/pictures/Makefile ===
EPS=	eps/big-pict.eps \
	eps/big-pict2.eps \
	eps/cfg-rev.eps \
	eps/cfg.eps \
	eps/compiler-2.eps \
	eps/compiler.eps \
	eps/compiler2.eps \
	eps/hyperblock-formation.eps \
	eps/if-conversion.eps \
	eps/layers.eps \
	eps/mlrisc-ir-archive.eps \
	eps/mlrisc-IR.eps \
	eps/phg.eps \
	eps/region-builder.eps \
	eps/subgraph.eps \
	eps/tail-dupl.eps \
	eps/tail-duplication.eps \
	eps/trace.eps \
	eps/uncol.eps \
	eps/viewer.eps

PNG=	png/compiler-1.png \
	png/compiler-2.png \
	png/hof-1.png \
	png/hof-2.png \
	png/mlrisc-ir-archive.png \
	png/optimization.png \
	png/sharing1.png \
	png/sharing2.png \
	png/sharing3.png \
	png/uncol.png \
	png/uncol1.png \
	png/uncol2.png


all:	mkdir $(EPS) $(PNG)

clean:	
	rm -f $(EPS) $(PNG)

mkdir:
	@if [ ! -d png ]; then mkdir png; fi
	@if [ ! -d eps ]; then mkdir eps; fi

eps/%.eps:	fig/%.fig
	fig2dev -L ps $< $@
jpeg/%.jpg:	fig/%.fig
	fig2dev -L jpeg $< $@
png/%.png:	fig/%.fig
	fig2dev -L png $< $@

=== benchmark/tests/Makefile ===
## Copyright (C) 1999-2006 Henry Cejtin, Matthew Fluet, Suresh
 #    Jagannathan, and Stephen Weeks.
 # Copyright (C) 1997-2000 NEC Research Institute.
 #
 # MLton is released under a BSD-style license.
 # See the file MLton-LICENSE for details.
 ##

all:

.PHONY: clean
clean:
	../../bin/clean
	rm -f *.c *.s
	for f in *; do 			\
		if [ -x "$$f" -a ! -d "$$f" ]; then	\
			rm -f "$$f";		\
		fi;				\
	done

=== doc/hacker-guide/Makefile ===
## Copyright (C) 1999-2006 Henry Cejtin, Matthew Fluet, Suresh
 #    Jagannathan, and Stephen Weeks.
 # Copyright (C) 1997-2000 NEC Research Institute.
 #
 # MLton is released under a BSD-style license.
 # See the file MLton-LICENSE for details.
 ##

TEX_FILES := \
	abstract.tex		\
	basis-library.tex	\
	main.tex		\
	macros.tex		\
	mlton.tex		\
	notes.tex		\
	runtime.tex		\
	sources.tex		\

FIG_FILES := \
	structure.ps		\

all:	main.ps

# -verbosity 0  be quieter (but not quiet enough for my taste)
# -address ''	puts no author address at the bottom of each page

main/main.html: $(TEX_FILES)
	latex2html -verbosity 1 -address '' -local_icons main.tex
	cd main && rm -f WARNINGS images.* *.pl
	cd main && rm -f index.html && ln -s main.html index.html

main.dvi: $(TEX_FILES) $(FIG_FILES)
	latex main; bibtex main; latex main; latex main

main.ps: main.dvi
	dvips -o main.ps main

%.ps: %.fig
	fig2dev -Leps $< $@

.PHONY: clean
clean:
	../../bin/clean

.PHONY: tags
tags:
	etags *.tex

=== doc/library-guide/Makefile ===
## Copyright (C) 1999-2006 Henry Cejtin, Matthew Fluet, Suresh
 #    Jagannathan, and Stephen Weeks.
 # Copyright (C) 1997-2000 NEC Research Institute.
 #
 # MLton is released under a BSD-style license.
 # See the file MLton-LICENSE for details.
 ##

TEX_FILES := \
	abstract.tex		\
	main.tex		\
	macros.tex		\

FIG_FILES := \

all:	main.ps

# -verbosity 0  be quieter (but not quiet enough for my taste)
# -address ''	puts no author address at the bottom of each page

main/main.html: $(TEX_FILES)
	latex2html -verbosity 1 -address '' -local_icons main.tex
	cd main && rm -f WARNINGS images.* *.pl
	cd main && rm -f index.html && ln -s main.html index.html

main.dvi: $(TEX_FILES) $(FIG_FILES)
	latex main; bibtex main; latex main; latex main

main.ps: main.dvi
	dvips -o main.ps main

%.ps: %.fig
	fig2dev -Leps $< $@

.PHONY: clean
clean:
	../../bin/clean

.PHONY: tags
tags:
	etags *.tex

=== debian/changelog ===
mlton (20100608-5.1ubuntu1) yakkety; urgency=medium

  * Build with -fPIC on amd64 since binaries there are now PIE; but also
    pass -no-pie to the linker for cases where not all objects we're linking
    are position-independent.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 09 Jul 2016 23:23:57 -0700

mlton (20100608-5.1) unstable; urgency=low

  * Non-Maintainer Upload
  * Apply upstream patch to avoid __gmp_const breakage
    (Closes: 707410)
  * Apply patch from Matthias Klose to allow building on more target
    triplets on i386, not just i486-linux-gnu (Closes: 640137)

 -- Florian Weimer <fw@deneb.enyo.de>  Sat, 19 Oct 2013 19:39:58 +0200

mlton (20100608-5) unstable; urgency=low

  * Newest gcc and binutils fix mips[el] jump problem
   * Uploaded mips[el] bootstrap packages as 20100608-4
   * Build-Depend on newest gcc and binutils
   * Removed explicit-relocs patch
  * Include a diffs to current release head
   * Necessary for 8-bit aligned MIPS read/writes
   * Increase heap-size for mips post-alignment
  * Building armel on debian buildd instead of qemu
   * Heap-size 1.2g on 1.5g machines
  * Added armhf port

 -- Wesley W. Terpstra (Debian) <terpstra@debian.org>  Tue, 19 Jul 2011 12:29:52 +0200

mlton (20100608-4) unstable; urgency=low

  * Add missing install file for sparc runtime
  * Make the self target symlink relative
  * Added Replaces and Breaks the old version for smooth upgrades
  * Previous build needed manual uploads, so buildd rebuild needed
  * Still needing bootstrap:
   * mips(el) gcc bug still unresolved and no-explicit-relocs fails too

 -- Wesley W. Terpstra (Debian) <terpstra@debian.org>  Fri, 01 Apr 2011 22:57:25 +0200

mlton (20100608-3) unstable; urgency=low

  * Include all bugfixes since 20100608 release
  * Depend on libgmp-dev (closes: #618268)
  * Split package into compiler, runtime, basis, tools, and doc
   * Use multiarch to support cross-compiling
   * Eliminates the need for a mlton-cross package
  * Updated standards version (no changes needed)

 -- Wesley W. Terpstra (Debian) <terpstra@debian.org>  Sun, 20 Mar 2011 14:05:32 +0100

mlton (20100608-2) unstable; urgency=low

  * Added a new '-mno-explicit-relocs' mips work-around.
   * Bug filed with gcc upstream (#44537)

 -- Wesley W. Terpstra (Debian) <terpstra@debian.org>  Mon, 14 Jun 2010 18:28:58 +0200

mlton (20100608-1) unstable; urgency=low

  * New upstream release
  * Removed the mips -fPIC work-around
   * Filing a new gcc bug report upstream

 -- Wesley W. Terpstra (Debian) <terpstra@debian.org>  Fri, 11 Jun 2010 16:11:59 +0200

mlton (20100504~svn-r7459) unstable; urgency=low

  * New snapshot from svn/HEAD
   * Includes fixes for PIC codegen on x86
   * Better handling of memory exhaustion
   * Fix aliasing problem with newest gcc
  * Switch to using quilt source format

 -- Wesley W. Terpstra (Debian) <terpstra@debian.org>  Tue, 04 May 2010 19:26:59 +0200

mlton (20100206~svn-r7414) unstable; urgency=low

  * s390 and hurd need fixed-heap to stop thrashing on resize
  * qemu'd armel needs max-heap to work-around mmap emulation problems
   => heap-size must choose {fixed/max}-heap

 -- Wesley W. Terpstra (Debian) <terpstra@debian.org>  Mon, 08 Feb 2010 20:22:20 +0100

mlton (20100206~svn-r7412) unstable; urgency=low

  * Restored -fPIC work-around and reopened #552314.
  * Got a qemu-linux-user with 1G of RAM to work => added armel target.

 -- Wesley W. Terpstra (Debian) <terpstra@debian.org>  Sat, 06 Feb 2010 11:16:31 +0100

mlton (20100205~svn-r7410) unstable; urgency=low

  * New snapshot from svn/HEAD
   * Split targets into sub-folder
   * makes cross-compiler packages possible
  * Add a debian/watch file for lintian
  * Correct spelling errors in the manual page
  * Updated to policy 3.8.4.0 (no changes)
  * Removed -fPIC work-around for mips (closes: #552314)

 -- Wesley W. Terpstra (Debian) <terpstra@debian.org>  Fri, 05 Feb 2010 17:13:06 +0100

mlton (20091212~svn-r7383) unstable; urgency=low

  * New snapshot from svn/HEAD
   * Works around incompatible change to 'patch' (closes: #560623)
  * Use a version number that reflects the snapshot nature (closes: #559014)
   * Both upstream and debian packaging live in the same svn repository
    * Prune the packaging folder from snapshots as well as releases
   * For release versions use 20YYMMDD-rXXX, where
    * 20YYMMDD is the name of the release soruce tarball
    * XXX is the svn version of the packaging used
   * For snapshots use 20YYMMDD~svn-rXXX, where
    * 20YYMMDD is the date the snapshot was made
    * XXX is the svn version of the packaging and source used

 -- Wesley W. Terpstra (Debian) <terpstra@debian.org>  Sat, 12 Dec 2009 02:37:12 +0100

mlton (20091107) unstable; urgency=low

  * gcc-4.4 miscompiles more than just fpclassify. It is unusable.
  * gcc-4.1 ICEs so also not an option.
  * => use gcc-4.3, despite an off-by-one bug in mips branch generation
  * Using -fPIC to compile changes the assembler enough to get past #552341

 -- Wesley W. Terpstra (Debian) <terpstra@debian.org>  Sat, 07 Nov 2009 17:26:11 +0100

mlton (20091104) unstable; urgency=low

  * Two more regressions disabled on hurd (thread2 and world5)
  * Switch mips back to gcc-4.4
   * Found the cause of the segfault: fpclassify is broken on mips
   * Disable its on linux/mips and use the MLton IEEE work-around code

 -- Wesley W. Terpstra (Debian) <terpstra@debian.org>  Wed, 04 Nov 2009 12:04:36 +0100

mlton (20091101) unstable; urgency=low

  * The mips saga continues
   * gcc-4.4 miscompiles code
   * gcc-4.3 outputs bad branch statements
   * => gcc-4.1 might work!
  * Don't override gcc version on any architecture but mips[el]
  * Change dependencies to require gcc-4.1 only on mips[el]

 -- Wesley W. Terpstra (Debian) <terpstra@debian.org>  Sun, 01 Nov 2009 18:38:37 +0100

mlton (20091029) unstable; urgency=low

  * Bump the heap-size up a bit to 800m (850m for align8) -> fixes s390.


=== debian/control ===
Source: mlton
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Wesley W. Terpstra (Debian) <terpstra@debian.org>
Build-Depends: mlton (>= 20070826), libgmp-dev, htmldoc, texlive-latex-base, procps, debhelper (>= 7.0.0), cdbs (>= 0.4.52), quilt, binutils (>= 2.21.51.201104) [mips mipsel], gcc (>= 4:4.6.0-5) [mips mipsel]
Standards-Version: 3.9.1

Package: mlton
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, mlton-compiler (>= ${source:Version}), mlton-compiler (<< ${source:Version}.1~), mlton-tools (>= ${source:Version}), mlton-tools (<< ${source:Version}.1~), mlton-doc (= ${source:Version})
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
 a fast C FFI, an interface to the GNU
 multiprecision library, and lots of useful
 libraries.
 .
 This metapackage depends on all MLton packages.

Package: mlton-basis
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Breaks: mlton (<< 20100608-3)
Replaces: mlton (<< 20100608-3)
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML - basis library
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
 a fast C FFI, an interface to the GNU
 multiprecision library, and lots of useful
 libraries.
 .
 This package includes the cross-platform basis.

Package: mlton-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Breaks: mlton (<< 20100608-3)
Replaces: mlton (<< 20100608-3)
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML - documentation
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
 a fast C FFI, an interface to the GNU
 multiprecision library, and lots of useful
 libraries.
 .
 This package includes non-man-page documentation.

Package: mlton-compiler
Architecture: alpha amd64 armel armhf hppa hurd-i386 i386 ia64 kfreebsd-i386 kfreebsd-amd64 mips mipsel powerpc s390 sparc
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, gcc, libc6-dev, libgmp-dev, mlton-basis (= ${source:Version}), mlton-runtime-native (= ${binary:Version}) | mlton-runtime
Breaks: mlton (<< 20100608-3)
Replaces: mlton (<< 20100608-3)
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML - compiler
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
 a fast C FFI, an interface to the GNU
 multiprecision library, and lots of useful
 libraries.
 .
 This package includes the compiler itself.

Package: mlton-tools
Architecture: alpha amd64 armel armhf hppa hurd-i386 i386 ia64 kfreebsd-i386 kfreebsd-amd64 mips mipsel powerpc s390 sparc
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: mlton (<< 20100608-3)
Replaces: mlton (<< 20100608-3)
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML - tools
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
 a fast C FFI, an interface to the GNU
 multiprecision library, and lots of useful
 libraries.
 .
 This package includes tools which autogenerate SML.

Package: mlton-runtime-native
Architecture: alpha amd64 armel armhf hppa hurd-i386 i386 ia64 kfreebsd-i386 kfreebsd-amd64 mips mipsel powerpc s390 sparc
Depends: ${misc:Depends}, mlton-runtime-alpha-linux-gnu (= ${binary:Version}) [alpha] | mlton-runtime-x86-64-linux-gnu (= ${binary:Version}) [amd64] | mlton-runtime-arm-linux-gnueabi (= ${binary:Version}) [armel] | mlton-runtime-arm-linux-gnueabihf (= ${binary:Version}) [armhf] | mlton-runtime-hppa-linux-gnu (= ${binary:Version}) [hppa] | mlton-runtime-i486-gnu (= ${binary:Version}) [hurd-i386] | mlton-runtime-i486-linux-gnu (= ${binary:Version}) [i386] | mlton-runtime-ia64-linux-gnu (= ${binary:Version}) [ia64] | mlton-runtime-i486-kfreebsd-gnu (= ${binary:Version}) [kfreebsd-i386] | mlton-runtime-x86-64-kfreebsd-gnu (= ${binary:Version}) [kfreebsd-amd64] | mlton-runtime-mips-linux-gnu (= ${binary:Version}) [mips] | mlton-runtime-mipsel-linux-gnu (= ${binary:Version}) [mipsel] | mlton-runtime-powerpc-linux-gnu (= ${binary:Version}) [powerpc] | mlton-runtime-s390-linux-gnu (= ${binary:Version}) [s390] | mlton-runtime-sparc-linux-gnu (= ${binary:Version}) [sparc]
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML - native runtime libraries
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
 a fast C FFI, an interface to the GNU
 multiprecision library, and lots of useful
 libraries.
 .
 This metapackage depends on native target libraries.

Package: mlton-runtime-alpha-linux-gnu
Architecture: alpha
Multi-Arch: foreign
Depends: ${misc:Depends}, mlton-basis (= ${source:Version})
Provides: mlton-runtime
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML - alpha runtime libraries
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
 a fast C FFI, an interface to the GNU
 multiprecision library, and lots of useful
 libraries.
 .
 This package provides alpha target libraries.

Package: mlton-runtime-x86-64-linux-gnu
Architecture: amd64
Multi-Arch: foreign
Depends: ${misc:Depends}, mlton-basis (= ${source:Version})
Provides: mlton-runtime
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML - amd64 runtime libraries
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
 a fast C FFI, an interface to the GNU
 multiprecision library, and lots of useful
 libraries.
 .
 This package provides x86-64 target libraries.

Package: mlton-runtime-arm-linux-gnueabi
Architecture: armel
Multi-Arch: foreign
Depends: ${misc:Depends}, mlton-basis (= ${source:Version})
Provides: mlton-runtime
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML - armel runtime libraries
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
 a fast C FFI, an interface to the GNU
 multiprecision library, and lots of useful
 libraries.
 .
 This package provides arm target libraries.

Package: mlton-runtime-arm-linux-gnueabihf
Architecture: armhf
Multi-Arch: foreign
Depends: ${misc:Depends}, mlton-basis (= ${source:Version})
Provides: mlton-runtime
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML - armhf runtime libraries
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
 a fast C FFI, an interface to the GNU
 multiprecision library, and lots of useful
 libraries.
 .
 This package provides armhf target libraries.

Package: mlton-runtime-hppa-linux-gnu
Architecture: hppa
Multi-Arch: foreign
Depends: ${misc:Depends}, mlton-basis (= ${source:Version})
Provides: mlton-runtime
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML - hppa runtime libraries
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
 a fast C FFI, an interface to the GNU
 multiprecision library, and lots of useful
 libraries.
 .
 This package provides hppa target libraries.

Package: mlton-runtime-i486-gnu
Architecture: hurd-i386
Multi-Arch: foreign
Depends: ${misc:Depends}, mlton-basis (= ${source:Version})
Provides: mlton-runtime
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML - hurd-i386 runtime libraries
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
 a fast C FFI, an interface to the GNU
 multiprecision library, and lots of useful
 libraries.
 .
 This package provides hurd i486 target libraries.

Package: mlton-runtime-i486-linux-gnu
Architecture: i386
Multi-Arch: foreign
Depends: ${misc:Depends}, mlton-basis (= ${source:Version})
Provides: mlton-runtime
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML - i386 runtime libraries
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
 a fast C FFI, an interface to the GNU
 multiprecision library, and lots of useful
 libraries.
 .
 This package provides i486 target libraries.

Package: mlton-runtime-ia64-linux-gnu
Architecture: ia64
Multi-Arch: foreign
Depends: ${misc:Depends}, mlton-basis (= ${source:Version})
Provides: mlton-runtime
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML - ia64 runtime libraries
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
 a fast C FFI, an interface to the GNU
 multiprecision library, and lots of useful
 libraries.
 .
 This package provides ia64 target libraries.

Package: mlton-runtime-i486-kfreebsd-gnu
Architecture: kfreebsd-i386
Multi-Arch: foreign
Depends: ${misc:Depends}, mlton-basis (= ${source:Version})
Provides: mlton-runtime
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML - kfreebsd-i386 runtime libraries
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,
 a fast C FFI, an interface to the GNU
 multiprecision library, and lots of useful
 libraries.
 .
 This package provides kfreebsd i386 target libraries.

Package: mlton-runtime-x86-64-kfreebsd-gnu
Architecture: kfreebsd-amd64
Multi-Arch: foreign
Depends: ${misc:Depends}, mlton-basis (= ${source:Version})
Provides: mlton-runtime
Homepage: http://mlton.org/
Description: Optimizing compiler for Standard ML - kfreebsd-amd64 runtime libraries
 MLton is a whole-program optimizing compiler
 for Standard ML.  MLton generates standalone 
 executables with excellent runtime performance,
 is SML 97 compliant, and has a complete basis
 library.  MLton has source-level profiling,

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/makefile.mk
include /usr/share/cdbs/1/rules/patchsys-quilt.mk

HEAPSIZE := $(shell . debian/heap-size)
	
# MLton compiles optimized, debug, and pic versions on its own.
DEB_MAKE_INVOKE = $(DEB_MAKE_ENVVARS) make -C $(DEB_BUILDDIR)

# The MLton guide is html. Don't compress example .sml files.
DEB_COMPRESS_EXCLUDE_ALL = mlton/guide .sml

DEB_MAKE_CLEAN_TARGET   = clean clean-svn
DEB_MAKE_BUILD_TARGET   = all RUNTIME_ARGS="$(HEAPSIZE)"
DEB_MAKE_INSTALL_TARGET = install-no-strip DESTDIR=$(CURDIR)/debian/tmp/ PREFIX=/usr MAN_PREFIX_EXTRA=/share
DEB_MAKE_CHECK_TARGET   = check

# Useful when inspecting build logs
common-configure-arch::
	free

# Move MLton target to per-architecture path
common-install-arch::
	mv $(CURDIR)/debian/tmp/usr/lib/mlton/targets/self $(CURDIR)/debian/tmp/usr/lib/mlton/targets/$(DEB_HOST_GNU_TYPE)
	ln -s $(DEB_HOST_GNU_TYPE) $(CURDIR)/debian/tmp/usr/lib/mlton/targets/self

# Remove licenses and empty directories to appease lintian
common-install-indep::
	find $(CURDIR)/debian/tmp -type d -empty -delete
	rm -rf $(CURDIR)/debian/tmp/usr/share/doc/mlton/license
	if test -n "$(DEB_ISNATIVE)"; then mv \
		$(CURDIR)/debian/tmp/usr/share/doc/mlton/changelog \
		$(CURDIR)/debian/tmp/usr/share/doc/mlton/changelog.PreviousRelease; \
	fi
